<template>
    <div class="main-container">
        <h1>My Article List</h1>
        <div v-if="profbool">
            <loader></loader>
        </div>
        <table class="u-full-width">
  <thead>
    <tr>
      <th>Headline</th>
      <th>Abstract</th>
      <th>Web Url</th>
      <th>Lead paragraph</th>
      <th>Publication Date</th>
      <th>Word Count</th>
      <th>Authors</th>
      <th></th>
    </tr>
  </thead>
  <tbody>
    <tr v-for="(article,index) in fav_articles" :key="index">
      <td>{{ article.headline_main }}</td>
      <td>{{ article.abstract }}</td>
      <td><a :href="article.web_url">{{ article.web_url }}</a></td>
      <td>{{ article.lead_paragraph }}</td>
      <td>{{ article.pub_date }}</td>
      <td>{{ article.word_count }}</td>
      <td>{{ article.byline }}</td>
      <td @click="onClickRemove(index,article.id)" class="delete-button"> X </td>
    </tr>
  </tbody>
</table>
<div class="pag-container">
<div class="pagination">
  <a href="#" @click="PrevPage()">&laquo;</a>
  <a href="#" class="current-page">{{ page }}</a>
  <a href="#" @click="NextPage()">&raquo;</a>
</div>
</div>

    </div>
</template>
<script>
import {httpClient} from "../api/httpclient"
import "../assets/normalize.css"
import "../assets/skeleton.css"
import axios from 'axios'
import vue from 'vue'
import VueAxios from 'vue-axios'
import loader from '../components/loader.vue'

vue.use(VueAxios,axios);


export default {
    name: "ArticleTable",
    data(){
        return{
             fav_articles : [],
             page : 1,
             next_url: '',
             prev_url:'',
             profbool:false
        }
    },
    created(){
        this.profbool = true;
        httpClient.get('/articles/saved_list/')
        .then((resp)=>{
            this.page = resp.data.page;
            this.next_url = resp.data.next_page;
            this.prev_url = resp.data.prev_page;

            this.fav_articles = resp.data.articles;
            console.log(resp);
            this.profbool = false;
        })

        
        
        


    },
    methods: {
        onClickRemove(index,id){
            let data = {
                id:id,
                page: this.page
            }
            // this.fav_articles.splice(index,1);
            // console.log(data);
            httpClient.delete('/articles/saved_list/',{data})
            .then((resp)=>{
                this.page = resp.data.page;
                this.next_url = resp.data.next_page;
                this.prev_url = resp.data.prev_page;

                this.fav_articles = resp.data.articles;
            });
        },
        PrevPage(){
            if(this.prev_url){
            
                httpClient.get(`/${this.prev_url}`)
                .then((resp)=>{
                    this.page = resp.data.page;
                    this.next_url = resp.data.next_page;
                    this.prev_url = resp.data.prev_page;

                    this.fav_articles = resp.data.articles;
                })
            }

        },
        NextPage(){
            if(this.next_url){
            
                httpClient.get(`/${this.next_url}`)
                .then((resp)=>{
                    this.page = resp.data.page;
                    this.next_url = resp.data.next_page;
                    this.prev_url = resp.data.prev_page;

                    this.fav_articles = resp.data.articles;
                })
            }

            
        }

    }}


</script>
<style scoped>
.main-container{
    margin:7%;
    min-height: 100vh;
}
.delete-button{
    cursor: pointer;
}
.pagination a {
  color: black;
  float: left;
  padding: 8px 16px;
  text-decoration: none;
  transition: background-color .3s;
}
.pagination a:hover:not(.current-page) {background-color: #ddd;}
 .pag-container{
     width: 100%;
     display: flex;
     justify-content: center;
 }

</style>
